//
//   COMPONENT_NAME: somx
//
//   ORIGINS: 27
//
//
//   10H9767, 10H9769  (C) COPYRIGHT International Business Machines Corp. 1992,1994
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/* %Z% %I% %W% %G% %U% [%H% %T%] */

/*
 *
 * DISCLAIMER OF WARRANTIES.
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard or IBM
 * product and is provided to you solely for the purpose of assisting
 * you in the development of your applications.  The code is provided
 * "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
 * THIS CODE.  IBM shall not be liable for any damages arising out of
 * your use of the sample code, even if they have been advised of the
 * possibility of such damages.
 *
 * DISTRIBUTION.
 * This sample code can be freely distributed, copied, altered, and
 * incorporated into other software, provided that it bears the above
 * Copyright notice and DISCLAIMER intact.
 */

#define VARIABLE_MACROS
#define METHOD_MACROS
#define Simple_Class_Source
#include "simple.xih"
#include <stdio.h>

/*
 * -- Instance Data Comment (actual defn in Simple.xih)
 */
/*
typedef struct {
	long x;
} SimpleData;
*/

/*
 * -- Method Procedures for Simple
 */

/*
 *  setX sets x, and returns self
 */

SOM_Scope Simple *  SOMLINK setX(Simple *somSelf,
		long x)
{

    SimpleData *somThis = SimpleGetData(somSelf);
    SimpleMethodDebug("Simple","setX");

    *(somSelf->_get_x()) = x; /* test explicit method call */
    return somSelf;
}

/*
 *  getX returns the current value of x
 */

SOM_Scope long   SOMLINK getX(Simple *somSelf)
{
    SimpleData *somThis = SimpleGetData(somSelf);
    SimpleMethodDebug("Simple","getX");

    return _x; /* test variable macro */
}

/*
 *  somInit initializes x to 42
 *  and then calls parent_somInit
 */

SOM_Scope void   SOMLINK somInit(Simple *somSelf)
{
    SimpleData *somThis = SimpleGetData(somSelf);
    SimpleMethodDebug("Simple","somInit");

    _setX(42);
    parent_SOMObject_somInit(somSelf); /* test method macro */
}
